/**
 * cnvm7tape: AZuCOMt@CMZ-700̃e[v`ɕϊ
 */



#include <stdio.h>



char prog_name[12] = "";
unsigned int f_size = 0;
unsigned int store_adrs = 0;
unsigned int run_adrs = 0;
char binary_file[20];



/* R}hCǂ */
void read_command_line(int argc, char *argv[])
{
    int j;

    if (argc == 1) {
        printf("usage: cnvm7tape COMFILE -s store_adrs -r run_adrs -n prog_name\n");
        exit(0);
    }

    for (j = 1; j < argc; j++) {
        if (strcmp(argv[j], "-s") == 0) {
            sscanf(argv[j + 1], "%x", &store_adrs);
            printf("store address: %04x\n", store_adrs);
            j++;

        } else if (strcmp(argv[j], "-r") == 0) {
            sscanf(argv[j + 1], "%x", &run_adrs);
            printf("run address: %04x\n", run_adrs);
            j++;

        } else if (strcmp(argv[j], "-n") == 0) {
            sscanf(argv[j + 1], "%s", prog_name);
            printf("program name: %s\n", prog_name);
            j++;

        } else {
            sscanf(argv[j], "%s", binary_file);
            printf("reading file: %s\n", binary_file);

        }
    }

    if (run_adrs == 0) {
        run_adrs = store_adrs;
        printf("run address: %04x\n", run_adrs);
    }
}



/* wb_(128oCg)o͂ */
void output_header(FILE *outfp)
{
    int j;

    /* Agr[g 0x00 */
    fputc('\x0', outfp);

    /* t@C 0x01 - 0x11 */
    for (j = 0; j < 17 && prog_name[j] !='\x0'; j++) {
        fputc(prog_name[j], outfp);
    }
    for (; j < 17; j++) {
        fputc('\xd', outfp);
    }

    /* t@CTCY 0x12 - 0x13 */
    fputc(f_size & 0xff, outfp);
    fputc((f_size >> 8) & 0xff, outfp);

    /* i[AhX 0x14 - 0x15 */
    fputc(store_adrs & 0xff, outfp);
    fputc((store_adrs >> 8) & 0xff, outfp);

    /* sAhX 0x16 - 0x17 */
    fputc(run_adrs & 0xff, outfp);
    fputc((run_adrs >> 8) & 0xff, outfp);

    /* 0x7f܂0Ŗ߂ */
    for (j = 0x18; j < 0x80; j++) {
        fputc(0x0, outfp);
    }
}



int main(int argc, char *argv[])
{
    FILE *infp;
    FILE *outfp;
    int c;

    read_command_line(argc, argv);

    /* oCit@C̃TCY𓾂 */
    infp = fopen(binary_file, "rb");
    fseek(infp, 0, SEEK_END);
    f_size = ftell(infp);
    printf("file size: %d, %xh\n", f_size, f_size);

    /* wb_o͂ */
    outfp = fopen(prog_name, "wb");
    output_header(outfp);

    /* oCit@CRs[ */
    fseek(infp, 0, SEEK_SET);
    while ((c = fgetc(infp)) != EOF) {
        fputc(c, outfp);
    }
}

